// compile: gcc -std=c99 -pthread -o pthreads pthreads.c
#include <pthread.h>
#include <stdio.h>

#define NTHREAD 4
#define ARRAYSIZE 1000000
double sum=0.0, a[ARRAYSIZE];
pthread_mutex_t sum_mutex;

void *add_array(void *tid) {
	int start = *(int *)tid * ((double)ARRAYSIZE / NTHREAD);
	int end = (*(int *)tid + 1) * ((double)ARRAYSIZE / NTHREAD);

	double my_sum = 0.0;
	for(int i=start; i<end; i++)
		my_sum += a[i];

	pthread_mutex_lock(&sum_mutex);
	sum += my_sum;
	pthread_mutex_unlock(&sum_mutex);
}


int main(void) {
	for(int i=0; i<ARRAYSIZE; i++) a[i] = 1;

	int tid[NTHREAD];
	pthread_t thread[NTHREAD];

	pthread_mutex_init(&sum_mutex, NULL);
	for(int i=0; i<NTHREAD; i++) {
		tid[i] = i;
		pthread_create(&thread[i], NULL, add_array, &tid[i]);
	}

	for(int i=0; i<NTHREAD; i++)
		pthread_join(thread[i], NULL);

	printf("sum = %.0f\n", sum);
}
