#include <chrono>
#include <iostream> 
#include <mutex> 
#include <random>
#include <thread>

static const int n_thread = 4;
static const int n_account = 1000;

int balance[n_account];

std::mutex mutex;

void thr_func()
{
	std::random_device rnd;
	for(int i=0; i<10000*n_account; i++) {
		int account1 = rnd() % n_account;
		int account2 = rnd() % n_account;
		int amount = rnd() % 100;

		__transaction_atomic
		//std::lock_guard<std::mutex> lock(mutex);
		{
			if(amount > balance[account1])
				amount = balance[account1];
			balance[account1] -= amount;
			balance[account2] += amount;

		}
	}	
}

int main(int argc, char *argv[])
{
	for(int i=0; i<n_account; i++) balance[i] = 100;

	typedef std::chrono::high_resolution_clock Clock;
	Clock::time_point t0 = Clock::now();

	std::thread thr[n_thread];
	for (auto &t : thr)
		t = std::thread(thr_func);

	for (auto &t : thr)
		t.join();

	Clock::time_point t1 = Clock::now();
	const double s = std::chrono::nanoseconds(t1 - t0).count() / 1e9;

	double total = 0;
	for (int i=0; i<n_account; i++) total += balance[i];

	std::cout << "average balance = " << total/n_account << std::endl;
	std::cout << "compute time = " << s << "s" << std::endl;
}

